function M = mwls(x,y,X,Y,G,stopien)
m = length(G);
p = 1;
if stopien==1
    p = 3;
elseif stopien==2
    p = 6;
end
if m==5
    p = 5;
end
P = zeros(m,p);
W = zeros(m,m);
for i=1:m
    h = X(G(i,1)) - x;
    k = Y(G(i,1)) - y;
    z = [1 h k 0.5*h^2 h*k 0.5*k^2];
    if m==5
        z = [1 h k 0.5*h^2 0.5*k^2];
    end
    P(i,:) = z(1:p);
    W(i,i) = 1/( sqrt(h^2 + k^2)^(1*(stopien+1)) + 10^-16);
end
if m==p
    M = P^-1;
else
    M = (P'*W*P)^-1 * P'*W;
end