function [PGx,PGy,WAG1] =  cal_troj(Ng1,X,Y,w)
PGx = zeros(1,Ng1);
PGy = zeros(1,Ng1);
WAG1 = zeros(1,Ng1);
switch Ng1
    case 1
        WAG1 = [1];
    case 3
        WAG1 = [1/3 1/3 1/3];
    case 4
        WAG1 = [-27/48 25/48 25/48 25/48];
    case 7
        WAG1 = [0.225 0.1323941527 0.1323941527 0.1323941527 0.1259391805 0.1259391805 0.1259391805];
    otherwise
        disp('ZLA LICZBA PUNKTW GAUSSA!');
        pause
end
switch Ng1
    case 1
        PGx(1) = (1./3.) * (X(w(1)) + X(w(2)) + X(w(3)));
        PGy(1) = (1./3.) * (Y(w(1)) + Y(w(2)) + Y(w(3)));
    case 3
        PGx(1) = 0.5*(X(w(1)) + X(w(2)));
        PGy(1) = 0.5*(Y(w(1)) + Y(w(2)));
        PGx(2) = 0.5*(X(w(2)) + X(w(3)));
        PGy(2) = 0.5*(Y(w(2)) + Y(w(3)));
        PGx(3) = 0.5*(X(w(1)) + X(w(3)));
        PGy(3) = 0.5*(Y(w(1)) + Y(w(3)));
    case 4
        PGx(1) = (X(w(1)) + X(w(2)) + X(w(3)))/3;
        PGy(1) = (Y(w(1)) + Y(w(2)) + Y(w(3)))/3;
        PGx(2) = 0.6*X(w(1)) + 0.2*X(w(2)) + 0.2*X(w(3));
        PGy(2) = 0.6*Y(w(1)) + 0.2*Y(w(2)) + 0.2*Y(w(3));
        PGx(3) = 0.2*X(w(1)) + 0.6*X(w(2)) + 0.2*X(w(3));
        PGy(3) = 0.2*Y(w(1)) + 0.6*Y(w(2)) + 0.2*Y(w(3));
        PGx(4) = 0.2*X(w(1)) + 0.2*X(w(2)) + 0.6*X(w(3));
        PGy(4) = 0.2*Y(w(1)) + 0.2*Y(w(2)) + 0.6*Y(w(3));
    case 7
        a1 = 0.0597158717;
        b1 = 0.4701420641;
        a2 = 0.7974269853;
        b2 = 0.1012865073;
        PGx(1) = (1/3)*(X(w(1)) + X(w(2)) + X(w(3)));
        PGy(1) = (1/3)*(Y(w(1)) + Y(w(2)) + Y(w(3)));
        PGx(2) = a1 * X(w(1)) + b1 * X(w(2)) + b1 * X(w(3));
        PGy(2) = a1 * Y(w(1)) + b1 * Y(w(2)) + b1 * Y(w(3));
        PGx(3) = b1 * X(w(1)) + a1 * X(w(2)) + b1 * X(w(3));
        PGy(3) = b1 * Y(w(1)) + a1 * Y(w(2)) + b1 * Y(w(3));
        PGx(4) = b1 * X(w(1)) + b1 * X(w(2)) + a1 * X(w(3));
        PGy(4) = b1 * Y(w(1)) + b1 * Y(w(2)) + a1 * Y(w(3));
        PGx(5) = a2 * X(w(1)) + b2 * X(w(2)) + b2 * X(w(3));
        PGy(5) = a2 * Y(w(1)) + b2 * Y(w(2)) + b2 * Y(w(3));
        PGx(6) = b2 * X(w(1)) + a2 * X(w(2)) + b2 * X(w(3));
        PGy(6) = b2 * Y(w(1)) + a2 * Y(w(2)) + b2 * Y(w(3));
        PGx(7) = b2 * X(w(1)) + b2 * X(w(2)) + a2 * X(w(3));
        PGy(7) = b2 * Y(w(1)) + b2 * Y(w(2)) + a2 * Y(w(3));
end