function rys_obszar(fig,PAR,Kr,Xk,Yk)
ms = wiadomosc(PAR,25);
figure(fig);
hold on
grid on
ilk = PAR(12);
for i=1:ilk
    n1 = Kr(i,1);
    n2 = Kr(i,2);
    kolor = 'k';   
    if PAR(37)==1
        if Kr(i,3)==1
            kolor = 'm';
        end
        if Kr(i,3)==2
            kolor = 'g';
        end
    end
    if Kr(i,5)==1
        plot([Xk(n1) Xk(n2)],[Yk(n1) Yk(n2)],[kolor '-'],'linewidth',6);
        text( (Xk(n1)+Xk(n2))/2 , (Yk(n1)+Yk(n2))/2 , [litera(PAR,2) num2str(i)],'FontSize',10,'BackgroundColor','g','EdgeColor','r','LineWidth',1);
    end
    if PAR(37)==1        
        log = 1;
        if Kr(i,3)==2 && Kr(i,4)==0
            log = 0;
        end
        if PAR(2)==2
            log = 1;
        end      
        if log==1
            lit = 'Q';
            if Kr(i,3)==1
                lit = 'T';
            end
            s1 = '';
            s2 = num2str(i);
            for j=1:length(s2)
                s1(2*j-1) = '_';
                s1(2*j) = s2(j);
            end
            if PAR(2)==1
                s = [lit,s1,'=',num2str(Kr(i,4))];
            end
            if PAR(2)==2
                s = [lit,s1,'(x,y)'];                
            end            
            text( (Xk(n1)+Xk(n2))/2 , (Yk(n1)+Yk(n2))/2,s,'FontSize',12,'BackgroundColor','w','EdgeColor',kolor,'LineWidth',2,'Color',kolor,'FontWeight','bold');
        end
    end
    if Kr(i,5)==2
        r1 = abs( Xk(n2) - Xk(n1) );
        r2 = abs( Yk(n2) - Yk(n1) );
        r = min([r1 r2]);
        x0 = min([Xk(n1) Xk(n2)]) + r;
        y0 = min([Yk(n1) Yk(n2)]) + r;
        c1 = (Xk(n1)-x0)/r;
        s1 = (Yk(n1)-y0)/r;
        c2 = (Xk(n2)-x0)/r;
        s2 = (Yk(n2)-y0)/r;      
        kat1 = kat(c1,s1);
        kat2 = kat(c2,s2);
        if abs(kat2)<10^-12
            kat2  = 2*pi;
        end
        alfa = kat1:0.01:kat2;
        x = x0 + r*cos(alfa);
        y = y0 + r*sin(alfa);
        plot(x,y,[kolor '-'],'linewidth',6);
    end    
end
plot(Xk,Yk,'bs','markerfacecolor','y');
xmin = min(Xk);
xmax = max(Xk);
ymin = min(Yk);
ymax = max(Yk);
dx = (xmax-xmin);
dy = (ymax-ymin);
d1 = 0.01;
d2 = 0.03;
for i=1:PAR(11)
    text(Xk(i)+d1*dx,Yk(i)-d2*dy,[litera(PAR,1) num2str(i)],'FontSize',10,'BackgroundColor','y','EdgeColor','k','LineWidth',1);
end
axis equal
d = 0.1;
if abs(dx)>10^-12 && abs(dy)>10^-12
    axis([xmin-d*dx xmax+d*dx ymin-d*dy ymax+d*dy]);
end
t=title('','FontWeight','bold','FontSize',12,'Color','r','BackGroundColor','y');
ile = PAR(13)-1;
if ile<0
    ile = 0;
end
set(t,'String',{tytul(PAR,1), [tytul(PAR,2) ' = ' num2str(PAR(11)) ' , ' tytul(PAR,3) ' = ' num2str(PAR(12))] , [tytul(PAR,16) ' = ' num2str(ile)]});

m = uicontextmenu;
s = 'off';
if PAR(37)==1
    s = 'on';
end
uimenu(m,'Label',nazwa(PAR,71),'Checked',s,'CallBack','PAR(37) = ~PAR(37); czysc_rys(fig,ilmen); rys_obszar(fig,PAR,Kr,Xk,Yk); ');
set(fig,'uicontextmenu',m);
set(gca,'uicontextmenu',m);
t = get(gca,'Children');
for i=1:length(t)
    set(t(i),'uicontextmenu',m);
end
close(ms);
