function [PAR,X0,Y0,WB0,T0,AKw0] = siatka(PAR,Xk,Yk,Kon,Kr,X,Y,WB,T,Xw,Yw,WBw,AKw,rys,opcja1)
global opcja;
if nargin<15
    opcja1 = 0;
end
% do zrobienia: algorytm numerowania krawdzi
[Krp Xp Yp] = linia_brzegowa(PAR,Kon,Kr,Xk,Yk);
if opcja1==0
    log = 0;
    opcjapom = opcja;
    while log==0
        opcja = opcjapom;
        pyt_siatka;
        log = 1;
        if opcja<0
            log = 0;
        end
    end
end
if PAR(9)==3 && PAR(39)==2
    PAR(20) = PAR(21);
end
X0 = X;
Y0 = Y;
WB0 = WB;
T0 = T;
AKw0 = AKw;
if opcja~=0
    if opcja1==0
        spr_obszar;
    end
    if opcja~=0
        if opcja1==0
            ms = wiadomosc(PAR,26);
        end
        nx = PAR(4);
        ny = PAR(5);       
        ilp = PAR(11);
        ilkon = PAR(13);
        ilk = PAR(12);
        zaburzenie_siatki = PAR(7);
        
        if PAR(20)==2 || (PAR(20)==1 && PAR(43)==1)
            Dlx = zeros(ilk,1);
            Dly = zeros(ilk,1);
            Dlxmin = 1;
            Dlymin = 1;
            eps = 10^-12;
            ilx = 0;
            ily = 0;
            for i=1:ilk
                n1 = Kr(i,1);
                n2 = Kr(i,2);
                x1 = Xk(n1);
                y1 = Yk(n1);
                x2 = Xk(n2);
                y2 = Yk(n2);
                dlx = abs(x2-x1);
                dly = abs(y2-y1);
                if abs(dlx)>eps
                    il = 0;
                    for j=1:ilx
                        if abs(Dlx(j,1)-dlx)<eps
                            il = il + 1;
                        end
                    end
                    if il==0
                        ilx = ilx + 1;
                        Dlx(ilx,1) = dlx;
                        Dlxmin = Dlxmin*dlx;
                    end
                end
                
                if abs(dly)>eps
                    il = 0;
                    for j=1:ily
                        if abs(Dly(j,1)-dly)<eps
                            il = il + 1;
                        end
                    end
                    if il==0
                        ily = ily + 1;
                        Dly(ily,1) = dly;
                        Dlymin = Dlymin*dly;
                    end
                end
            end
            Dlx(ilx+1:end) = [];
            Dly(ily+1:end) = [];
            Dlxmin = Dlx(1);
            for i=1:ilx-1
                if i==1
                    a = Dlx(i,1);
                else
                    a = Dlxmin;
                end
                b = Dlx(i+1,1);
                Dlxmin = NWD(a,b);
            end
            
            Dlymin = Dly(1);
            for i=1:ily-1
                if i==1
                    a = Dly(i,1);
                else
                    a = Dlymin;
                end
                b = Dly(i+1,1);
                Dlymin = NWD(a,b);
            end
            
            xmax = max(Xp);
            xmin = min(Xp);
            ymax = max(Yp);
            ymin = min(Yp);
            nhx = PAR(4);
            nhy = PAR(5);
            if PAR(43)==1
                nhy = nhx;
            end
            hxc = Dlxmin/(nhx-1);
            hyc = Dlymin/(nhy-1);
            nxc = round((xmax - xmin)/hxc + 1);
            nyc = round((ymax - ymin)/hyc + 1);
            nc = nxc*nyc;
            Xc = zeros(nc,1);
            Yc = zeros(nc,1);
            x = xmin;
            y = ymin;
            j = 1;
            for i=1:nc
                Xc(i) = x;
                Yc(i) = y;
                x = x + hxc;
                j = j + 1;
                if j>nxc % przejcie na jeden poziom wyej
                    j = 1;
                    x = xmin;
                    y = y + hyc;
                end
            end
            Pc = struct([]);
            il = 0;
            for j=1:nyc-1
                for i=1:nxc-1
                    n1 = i + (j-1)*nxc;
                    n2 = i + 1 + (j-1)*nxc;
                    n3 = i + 1 + (j)*nxc;
                    n4 = i + j*nxc;
                    Pc(il+1).X = [Xc(n1) Xc(n2)];
                    Pc(il+1).Y = [Yc(n1) Yc(n3)];
                    Pc(il+1).w = [n1 n2 n3 n4];
                    xs = 0.5*(sum(Pc(il+1).X));
                    ys = 0.5*(sum(Pc(il+1).Y));
                    %Pc(il+1).c1 = pwew(xs,ys,Xp,Yp,ilp);
                    pocz = Kon(1,3);
                    kon = Kon(1,4);
                    Pc(il+1).c1 = pwew(xs,ys,Xp(pocz:kon),Yp(pocz:kon),Kon(1,1));
                    Pc(il+1).c2 = potw(xs,ys,ilkon,Kon,Xp,Yp);
                    if Pc(il+1).c1==1 && Pc(il+1).c2==0
                        c = 1;
                        for k=1:4
                            x = Xc(Pc(il+1).w(k));
                            y = Yc(Pc(il+1).w(k));
                            %c1 = pwew(x,y,Xp,Yp,ilp);
                            c1 = pwew(x,y,Xp(pocz:kon),Yp(pocz:kon),Kon(1,1));
                            c2 = potw(x,y,ilkon,Kon,Xp,Yp);
                            c3 = pbrzeg(x,y,ilk,Kr,Xk,Yk);
                            if (c1==0 || c2==1) && c3==0
                                c = 0;
                            end
                        end
                        if c==1
                            il = il + 1;
                        end
                    end
                end
            end
            Xc1 = zeros(nc,1);
            Yc1 = zeros(nc,1);
            nc = il;
            eps = 10^-12;
            ilc = 0;
            for i=1:nc
                w = Pc(i).w;
                w1 = zeros(4,1);
                for j=1:4
                    x = Xc(w(j));
                    y = Yc(w(j));
                    il = 0;
                    for k=1:ilc
                        d = sqrt( (x - Xc1(k))^2 + (y - Yc1(k))^2 );
                        if d<eps
                            il = k;
                        end
                    end
                    if il==0
                        ilc = ilc + 1;
                        Xc1(ilc) = x;
                        Yc1(ilc) = y;
                        il = ilc;
                    end
                    w1(j) = il;
                end
                Pc(i).w = w1;
                Pc(i).X = [Xc1(w1(1)) Xc1(w1(2))];
                Pc(i).Y = [Yc1(w1(1)) Yc1(w1(3))];
            end
            Xc1(ilc+1:end) = [];
            Yc1(ilc+1:end) = [];
            Xc = Xc1;
            Yc = Yc1;
            clear Xc1 Yc1;
            WBc = zeros(ilc,4);
            for i=1:ilc
                [WBc(i,1) nrkr] = pbrzeg(Xc(i),Yc(i),ilk,Kr,Xk,Yk);
                if WBc(i,1)==1
                    WBc(i,2) = length(nrkr);
                    for j=1:length(nrkr)
                        WBc(i,2+j) = nrkr(j);
                    end
                end
            end
            X = Xc;
            Y = Yc;
            WB = WBc;
            n = ilc;
            ile = nc;
            T = zeros(ile,4);
            for i=1:ile
                T(i,:) = Pc(i).w;
            end                        
        end
        
        if PAR(20)==1 && PAR(43)==0
            xmax = max(Xk);
            xmin = min(Xk);
            ymin = min(Yk);
            ymax = max(Yk);
            hx = (xmax - xmin)/(nx-1);
            hy = (ymax - ymin)/(ny-1);            
            n = PAR(14);
            if opcja1==0
                X = zeros(nx*ny,1);
                Y = zeros(nx*ny,1);
                WB = zeros(nx*ny,4);
                
                WB(1:ilp,1) = 1;
                WB(1:ilp,2) = 2;
                X(1:ilp) = Xk;
                Y(1:ilp) = Yk;
                for i=1:ilp
                    il = 0;
                    for j=1:ilk
                        if Kr(j,1)==i || Kr(j,2)==i
                            il = il + 1;
                            WB(i,2+il) = j;
                        end
                    end
                end
                n = ilp;                                
                
                for i=1:ilk
                    n1 = Kr(i,1);
                    n2 = Kr(i,2);
                    dlx = abs(Xk(n2) - Xk(n1));
                    dly = abs(Yk(n2) - Yk(n1));
                    dl = sqrt( dlx^2 + dly^2 );
                    s = (Yk(n2) - Yk(n1))/dl;
                    c = (Xk(n2) - Xk(n1))/dl;
                    nxk = ceil(nx*dlx/(xmax-xmin));
                    nyk = ceil(ny*dly/(ymax-ymin));
                    nk = max([nxk nyk]);
                    h = dl/(nk-1);
                    for j=2:nk-1
                        n = n + 1;
                        X(n) = Xk(n1) + h*c*(j-1);
                        Y(n) = Yk(n1) + h*s*(j-1);
                        WB(n,:) = [1 1 i 0];
                    end
                end                                
                
                x = xmin;
                y = ymin;
                npop = n;
                for i=1:ny
                    for j=1:nx
                        pocz = Kon(1,3);
                        kon = Kon(1,4);
                        %c1 = pwew(x,y,Xk(pocz:kon),Yk(pocz:kon),Kon(1,1));
                        c1 = pwew(x,y,Xp(pocz:kon),Yp(pocz:kon),Kon(1,1));
                        c2 = pbrzeg(x,y,ilk,Kr,Xk,Yk);
                        c3 = potw(x,y,ilkon,Kon,Xp,Yp);
                        if c1==1 && c2==0 && c3==0
                            dmin = realmax;
                            for k=1:npop
                                d = sqrt( (x - X(k))^2 + (y - Y(k))^2 );
                                if d<dmin
                                    dmin = d;
                                end
                            end
                            if dmin>=(1/3)*max([hx,hy])
                                n = n + 1;
                                X(n) = x;
                                Y(n) = y;
                                WB(n,:) = [0 0 0 0];
                            end
                        end
                        x = x + hx;
                    end
                    y = y + hy;
                    x = xmin;
                end
                
                X(n+1:end) = [];
                Y(n+1:end) = [];
                WB(n+1:end,:) = [];
                
                if zaburzenie_siatki==1
                    for i=1:n
                        if WB(i,1)==0
                            X(i) = X(i) + amp_zab*(0.5-rand(1,1))*hx;
                            Y(i) = Y(i) + amp_zab*(0.5-rand(1,1))*hy;
                        end
                    end
                end
            end
            
            %X
            %Y
            %T = delaunay(X,Y,{'Qt','Qbb','Qc','Qz'});
            T = delaunay(X,Y);
            ile = size(T,1);
            
            T1 = zeros(ile,3);
            ile1 = 0;
            
            for i=1:ile
                xs = (1/3)*sum(X(T(i,:)));
                ys = (1/3)*sum(Y(T(i,:)));
                pocz = Kon(1,3);
                kon = Kon(1,4);
                %c1 = pwew(xs,ys,Xk(pocz:kon),Yk(pocz:kon),Kon(1,1));
                c1 = pwew(xs,ys,Xp(pocz:kon),Yp(pocz:kon),Kon(1,1));
                %c2 = potw(xs,ys,ilkon,Kon,Xk,Yk);
                c2 = potw(xs,ys,ilkon,Kon,Xp,Yp);
                %c1 = 1;
                %c2 = 0;
                if c1==1 && c2==0
                    ile1 = ile1 + 1;
                    T1(ile1,:) = T(i,:);
                end
            end
            T1(ile1+1:end,:) = [];
            ile = ile1;
            T = T1;
            
            if PAR(20)==1 && opcja1==0
                nr = ilp;
                iled = 0;
                Td = zeros(ile,3);
                for i=1:ilk
                    n1 = Kr(i,1);
                    n2 = Kr(i,2);
                    dlx = abs(Xk(n2) - Xk(n1));
                    dly = abs(Yk(n2) - Yk(n1));
                    nxk = ceil(nx*dlx/(xmax-xmin));
                    nyk = ceil(ny*dly/(ymax-ymin));
                    nk = max([nxk nyk]);
                    for j=2:nk
                        if j<nk
                            nr = nr + 1;
                        end
                        nr1 = nr - 1;
                        if j==2
                            nr1 = Kr(i,1);
                        end
                        nr2 = nr;
                        if j==nk
                            if j>2
                                nr1 = nr;
                            end
                            nr2 = Kr(i,2);
                        end
                        xs = 0.5*(X(nr1) + X(nr2));
                        ys = 0.5*(Y(nr1) + Y(nr2));
                        el = 0;
                        k=1;
                        while (k<=ile && el==0)
                            for p=1:3
                                nrp = T(k,p);
                                if p<3
                                    nrk = T(k,p+1);
                                else
                                    nrk = T(k,1);
                                end
                                xs1 = 0.5*(X(nrp) + X(nrk));
                                ys1 = 0.5*(Y(nrp) + Y(nrk));
                                d = sqrt( (xs-xs1)^2 + (ys-ys1)^2 );
                                if d<10^-12
                                    el = k;
                                end
                            end
                            k = k + 1;
                        end
                        if el==0
                            dmin = realmax;
                            wez = 0;
                            for k=1:n
                                if WB(k,1)==0
                                    d = sqrt( (xs - X(k))^2 + (ys - Y(k))^2 );
                                    if d<dmin
                                        dmin = d;
                                        wez = k;
                                    end
                                end
                            end
                            if wez>0
                                iled = iled + 1;
                                Td(iled,:) = [nr1 nr2 wez];
                            end
                        end
                    end
                end
                if iled>0
                    T1 = zeros(ile+iled,3);
                    T1(1:ile,:) = T(1:ile,:);
                    T1(ile+1:ile+iled,:) = Td(1:iled,:);
                    T = T1;
                    ile = ile + iled;
                end
            end
        end
        
        PAR(14:16) = [n ile 3];
        if opcja1==0
            PAR(28) = n;
            PAR(29) = 0;
            for i=1:PAR(26)
                AKw(i) = 0;
            end
        end
        PAR(18) = 2;
        PAR(19) = 0;        
        %     for i=1:length(wsk1)-1
        %         set(wsk1(i),'Enable','on');
        %     end
        %     for i=1:length(wsk2)
        %         set(wsk2(i),'Enable','off');
        %     end
        %     if PAR(2)==2
        %         set(wsk1(end),'Enable','on');
        %     end
        X0 = X;
        Y0 = Y;
        WB0 = WB;
        T0 = T;
        AKw0 = AKw;
        
        if PAR(20)==1 && PAR(43)==1
            wiad = 0;
            konw_siatka;
        end
        
        if opcja1==0
            close(ms);
            uiwait(msgbox(info(PAR,1),'INFO','help','modal'));
        end
        PAR(23:24) = 0;                
        
        if rys==1 && n<=5000
            subplot(1,1,1);
            rys_siatka(1,PAR,Xk,Yk,Kr,X,Y,WB,T,Xw,Yw,WBw,AKw);
        end
    end
end